diff --git a/src/main/java/org/orekit/estimation/sequential/KalmanModel.java b/src/main/java/org/orekit/estimation/sequential/KalmanModel.java
index 404abce0a..113f73431 100644
--- a/src/main/java/org/orekit/estimation/sequential/KalmanModel.java
+++ b/src/main/java/org/orekit/estimation/sequential/KalmanModel.java
@@ -274,7 +274,7 @@ public class KalmanModel extends KalmanEstimationCommon implements NonLinearProc
             for (final ParameterDriver driver : observedMeasurement.getParametersDrivers()) {
                 if (driver.isSelected()) {
                     // Derivatives of current measurement w/r to selected measurement parameter
-                    final double[] aMPm = predictedMeasurement.getParameterDerivatives(driver);
+                    final double[] aMPm = predictedMeasurement.getParameterDerivatives(driver, observedMeasurement.getDate());
 
                     // Check that the measurement parameter is managed by the filter
                     if (measurementParameterColumns.get(driver.getName()) != null) {
@@ -372,7 +372,7 @@ public class KalmanModel extends KalmanEstimationCommon implements NonLinearProc
         // Update the parameters with the estimated state
         // The min/max values of the parameters are handled by the ParameterDriver implementation
         setCorrectedEstimate(estimate);
-        updateParameters();
+        updateParameters(observedMeasurement.getDate());
 
         // Get the estimated propagator (mirroring parameter update in the builder)
         // and the estimated spacecraft state
@@ -440,23 +440,23 @@ public class KalmanModel extends KalmanEstimationCommon implements NonLinearProc
     /** Update the estimated parameters after the correction phase of the filter.
      * The min/max allowed values are handled by the parameter themselves.
      */
-    private void updateParameters() {
+    private void updateParameters(AbsoluteDate date) {
         final RealVector correctedState = getCorrectedEstimate().getState();
         int i = 0;
         for (final DelegatingDriver driver : getEstimatedOrbitalParameters().getDrivers()) {
             // let the parameter handle min/max clipping
-            driver.setNormalizedValue(correctedState.getEntry(i));
+            driver.setNormalizedValue(correctedState.getEntry(i), date);
             correctedState.setEntry(i++, driver.getNormalizedValue());
         }
         for (final DelegatingDriver driver : getEstimatedPropagationParameters().getDrivers()) {
             // let the parameter handle min/max clipping
-            driver.setNormalizedValue(correctedState.getEntry(i));
+            driver.setNormalizedValue(correctedState.getEntry(i), date);
             correctedState.setEntry(i++, driver.getNormalizedValue());
         }
         for (final DelegatingDriver driver : getEstimatedMeasurementsParameters().getDrivers()) {
             // let the parameter handle min/max clipping
-            driver.setNormalizedValue(correctedState.getEntry(i));
-            correctedState.setEntry(i++, driver.getNormalizedValue());
+            driver.setNormalizedValue(correctedState.getEntry(i), date);
+            correctedState.setEntry(i++, driver.getNormalizedValue(date));
         }
     }
 