diff --git a/src/main/java/org/orekit/models/earth/atmosphere/data/CssiSpaceWeatherData.java b/src/main/java/org/orekit/models/earth/atmosphere/data/CssiSpaceWeatherData.java
index 793ef2230d4dd0ed244bca61682453d1cb58c463..39b950ff38d2fc1dd1f11988bdf0d4563cfa0079 100644
--- a/src/main/java/org/orekit/models/earth/atmosphere/data/CssiSpaceWeatherData.java
+++ b/src/main/java/org/orekit/models/earth/atmosphere/data/CssiSpaceWeatherData.java
@@ -188,7 +188,9 @@ public class CssiSpaceWeatherData extends AbstractSelfFeedingLoader
         return previousValue * previousWeight + nextValue * nextWeight;
     }
 
-    /** {@inheritDoc} */
+    /** {@inheritDoc}
+     * For the DTM2000 model, we are using the adjusted flux
+     */
     public double getInstantFlux(final AbsoluteDate date) {
         // Interpolating two neighboring daily fluxes
         // get the neighboring dates
@@ -197,11 +199,18 @@ public class CssiSpaceWeatherData extends AbstractSelfFeedingLoader
     }
 
     /** {@inheritDoc}
-     * FIXME not sure if the mean flux for DTM2000 should be computed differently
-     * than the average flux for NRLMSISE00
+     * For the DTM2000 model, we are using the adjusted flux
      */
     public double getMeanFlux(final AbsoluteDate date) {
-        return getAverageFlux(date);
+        if (date.compareTo(lastDailyPredictedDate) <= 0) {
+            bracketDate(date);
+            return previousParam.getCtr81Adj();
+        } else {
+            // Only monthly data is available, better interpolate between two months
+            // get the neighboring dates
+            bracketDate(date);
+            return getLinearInterpolation(date, previousParam.getCtr81Adj(), nextParam.getCtr81Adj());
+        }
     }
 
     /** {@inheritDoc} */
@@ -252,6 +261,7 @@ public class CssiSpaceWeatherData extends AbstractSelfFeedingLoader
 
     /**
      * Gets the daily flux on the current day.
+     * For the NRLMSISE00 model, we are using the observed flux
      *
      * @param date the current date
      * @return the daily F10.7 flux (adjusted)
@@ -260,25 +270,27 @@ public class CssiSpaceWeatherData extends AbstractSelfFeedingLoader
         if (date.compareTo(lastDailyPredictedDate) <= 0) {
             // Getting the value for the previous day
             bracketDate(date);
-            return previousParam.getF107Adj();
+            return previousParam.getF107Obs();
         } else {
             // Only monthly data is available, better interpolate between two months
             // get the neighboring dates
             bracketDate(date);
-            return getLinearInterpolation(date, previousParam.getF107Adj(), nextParam.getF107Adj());
+            return getLinearInterpolation(date, previousParam.getF107Obs(), nextParam.getF107Obs());
         }
     }
 
-    /** {@inheritDoc} */
+    /** {@inheritDoc}
+     * For the NRLMSISE00 model, we are using the observed flux
+     */
     public double getAverageFlux(final AbsoluteDate date) {
         if (date.compareTo(lastDailyPredictedDate) <= 0) {
             bracketDate(date);
-            return previousParam.getCtr81Adj();
+            return previousParam.getCtr81Obs();
         } else {
             // Only monthly data is available, better interpolate between two months
             // get the neighboring dates
             bracketDate(date);
-            return getLinearInterpolation(date, previousParam.getCtr81Adj(), nextParam.getCtr81Adj());
+            return getLinearInterpolation(date, previousParam.getCtr81Obs(), nextParam.getCtr81Obs());
         }
     }
 
diff --git a/src/test/java/org/orekit/models/earth/atmosphere/data/CssiSpaceWeatherLoaderTest.java b/src/test/java/org/orekit/models/earth/atmosphere/data/CssiSpaceWeatherLoaderTest.java
index 51767fd44539a31debf159bee312df61d39fbe37..69d630652ede82c7efb4d0b8eb5726c34ab274d4 100644
--- a/src/test/java/org/orekit/models/earth/atmosphere/data/CssiSpaceWeatherLoaderTest.java
+++ b/src/test/java/org/orekit/models/earth/atmosphere/data/CssiSpaceWeatherLoaderTest.java
@@ -190,7 +190,7 @@ public class CssiSpaceWeatherLoaderTest {
         AbsoluteDate date = new AbsoluteDate(2000, 1, 1, 0, 0, 0.0, utc);
         final double dailyFlux = cswl.getDailyFlux(date);
         // The daily flux is supposed to be the one from 1999-12-31
-        assertThat(dailyFlux, closeTo(125.8, 1e-10));
+        assertThat(dailyFlux, closeTo(130.1, 1e-10));
     }
 
     @Test
@@ -198,7 +198,23 @@ public class CssiSpaceWeatherLoaderTest {
         CssiSpaceWeatherData cswl = loadCswl();
         AbsoluteDate date = new AbsoluteDate(2034, 6, 17, 0, 0, 0.0, utc);
         final double dailyFlux = cswl.getDailyFlux(date);
-        assertThat(dailyFlux, closeTo((136.4 + 141.9) / 2, 1e-3));
+        assertThat(dailyFlux, closeTo((132.7 + 137.3) / 2, 1e-3));
+    }
+
+    @Test
+    public void testMeanFlux() {
+        CssiSpaceWeatherData cswl = loadCswl();
+        AbsoluteDate date = new AbsoluteDate(2000, 1, 1, 0, 0, 0.0, utc);
+        final double meanFlux = cswl.getMeanFlux(date);
+        assertThat(meanFlux, closeTo(158.6, 1e-10));
+    }
+
+    @Test
+    public void testMeanFluxMonthlyPredicted() {
+        CssiSpaceWeatherData cswl = loadCswl();
+        AbsoluteDate date = new AbsoluteDate(2034, 6, 16, 0, 0, 0.0, utc);
+        final double meanFlux = cswl.getMeanFlux(date);
+        assertThat(meanFlux, closeTo((134.8 + 138.8) / 2, 1e-3));
     }
 
     @Test
@@ -206,7 +222,7 @@ public class CssiSpaceWeatherLoaderTest {
         CssiSpaceWeatherData cswl = loadCswl();
         AbsoluteDate date = new AbsoluteDate(2000, 1, 1, 0, 0, 0.0, utc);
         final double averageFlux = cswl.getAverageFlux(date);
-        assertThat(averageFlux, closeTo(158.6, 1e-10));
+        assertThat(averageFlux, closeTo(165.6, 1e-10));
     }
 
     @Test
@@ -214,7 +230,7 @@ public class CssiSpaceWeatherLoaderTest {
         CssiSpaceWeatherData cswl = loadCswl();
         AbsoluteDate date = new AbsoluteDate(2034, 6, 16, 0, 0, 0.0, utc);
         final double averageFlux = cswl.getAverageFlux(date);
-        assertThat(averageFlux, closeTo((134.8 + 138.8) / 2, 1e-3));
+        assertThat(averageFlux, closeTo((132.1 + 134.9) / 2, 1e-3));
     }
 
     @Test